                { Apr 20, 1992 }

unit window;
interface
uses Graph, NKK;

{-------------------- begin window -----------------------------------------}
const windMaxRow=20;
      windMaxColumns=40;
type windTextType=array[1..windMaxRow] of string[windMaxColumns];
     windRectangleType=array[1..4] of pointtype;

     windType=record
                 tex: windTextType;
                 numcol, numrow: integer;
                 rect: windRectangleType;
                 pt:  pointer;
                 ptnumbyte: word;
                 bool: boolean;     { on screen ! }
                 by: byte;          { type of information }
              end;

procedure OpenWind(var wind: windtype);
procedure CloseWind(var wind: windtype);
procedure WriteWind(var wind: windtype);

procedure OpenCloseWind(var wind: windtype; ca: byte);

const wind1: windType=
(tex:(empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,
      empty,empty,empty,empty,empty,empty,empty,empty);
 numcol:29; numrow:10;
 rect:((x:400;y:20),(x:639;y:20),(x:639;y:120),(x:400;y:120));
 pt: nil;
 ptnumbyte:0;
 bool:false; by:2);

 const wind2: windType=
(tex:(empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,empty,
      empty,empty,empty,empty,empty,empty,empty,empty);
 numcol:29; numrow:10;
 rect:((x:0;y:15),(x:80;y:15),(x:80;y:330),(x:0;y:330));
 pt: nil;
 ptnumbyte:0;
 bool:false; by:2);

{-------------------- end window ------------------------------------}

implementation
procedure OpenWind;  { Save the picture under window }
begin
   with wind do
      if pt=nil then
   begin
      ptnumbyte:=ImageSize(rect[1].x,rect[1].y,rect[3].x,rect[3].y);
      if MaxAvail<ptnumbyte then
      begin
         bool:=false;
         WrE;
         Wr('No enough memory to create window !',12);
         stop;
         WrE;
      end else
      begin
         GetMem(pt,ptnumbyte);
         GetImage(rect[1].x,rect[1].y,rect[3].x,rect[3].y,pt^);
      end;
   end;
end;
{----------------------------------------------------------------------------}
procedure CloseWind;  { Restore the picture under window }
begin
   with wind do
      if pt<>nil then
   begin
      PutImage(rect[1].x,rect[1].y,pt^,CopyPut);
      FreeMem(pt,ptnumbyte);
      pt:=nil;
      bool:=false;
   end;
end;
{----------------------------------------------------------------------------}
procedure WriteWind;      { Write window with text ! }
var i: integer;
begin
   with wind do
      if (pt<>nil) and bool then
   begin
      SetColor(5);
      SetFillStyle(SolidFill,7);

      FillPoly(4,rect);
      SetColor(0);
      for i:=1 to numrow do
         OutTextXY(rect[1].x+2,rect[1].y+2+(i-1)*10,tex[i]);
   end;
end; { windText }
{-------------------------------------------------------------------------}
procedure OpenCloseWind;
begin
   with wind do
   begin
      bool:=not bool;
      if bool then
      begin
         OpenWind(wind); by:=ca;
         writeWind(wind);
      end else CloseWind(wind);
   end;
end;
{-------------------------------------------------------------------------}

end.