               { May 18, 1992 }                { ds }

program DS;
uses Crt,Graph, fun, window, NKK;

var x1, x2, y1, y2: numType;
    alx, aly, bex,bey: numType;
    stepX, stepMu, currX: numType;
    stepXdrawF: numType;
    muLong: numType;

const maxIter: word=20;
      hidIter: word=0;

var GMY, GMY0: integer;

const wr1s: string=empty;
{---------------------------------------------------------------------------}
procedure Wr2;
begin
   GotoXY(40,1); write(space:40);
   GotoXY(40,1);
   if comp=1 then write(wr1s)
             else write(wr1s);
end;
{---------------------------------------------------------------------------}
procedure Wr1;
begin
   GotoXY(1,1); write(space:80);
   GotoXY(1,1);
   if comp=1 then write(numDS:2,':F(x)=',fstr[numDS],'     Mu=',mu:5:2)
             else write(numDS:2,':F(x)=',fstr[numDS],'&',comp,'  Mu=',mu:5:2);
   Wr2;
end;
{---------------------------------------------------------------------------}
procedure Grafic;

procedure DrawF(co: byte);
var x,r : numType;
    ix, iy, i: integer;
begin
   if co=0 then SetColor(0)
           else SetColor(co+1-comp);
   x:=x1;

   ix:=Trxy(alx,bex,x);
   r:=F(x,comp);
   if abs(r)<1000 then iy:=GMY-Trxy(aly,bey,F(x,comp)) else iy:=-200;
   MoveTo(ix,iy);
   repeat
      x:=x+stepxdrawF;
      ix:=Trxy(alx,bex,x);
      r:=F(x,comp);
      if abs(r)<1000 then iy:=GMY-Trxy(aly,bey,r) else iy:=-200;
      if (ix>-100) and (ix<GetMaxX+100) and
         (iy>-100) and (iy<GetMaxY+100) then LineTo(ix,iy)
                                        else MoveTo(ix,iy);
   until x>x2;
   SetColor(12);
   Line(Trxy(alx,bex,0),GMY0,Trxy(alx,bex,0),GMY);
   Line(GetMaxX,GMY-Trxy(aly,bey,0),0,GMY-Trxy(aly,bey,0));
   x:=2*abs(x2-x1);
   Line(Trxy(alx,bex,x),GMY-Trxy(aly,bey,x),
        Trxy(alx,bex,-x),GMY-Trxy(aly,bey,-x));
(*
   SetColor(10);
   for i:=1 to numFix do circle(Trxy(alx,bex,Fix[i]),GMY-Trxy(aly,bey,0),2);
*)
end;
{------------------------------------------------------------------------}
procedure FixPoint;
var i, iend: integer;
begin
   AllFix(x1,x2);
   with wind1 do
   begin
      Tex[1]:=empty;
      Tex[2]:=' '+StrI(numFix,0)+' fixed points ';
      Tex[3]:=' in ['+StrR(x1,5,1)+','+StrR(x2,5,1)+']';
      Tex[4]:=empty;
      if numFix<6 then iend:=numFix else iend:=6;
      for i:=1 to iend do Tex[4+i]:='x='+StrR(Fix[i],8,3)+
                                    '   dx='+StrR(DFix[i],8,3);
      for i:=iend+5 to 10 do Tex[i]:=empty;
   end;
   if wind1.pt<>nil then WriteWind(wind1);
end;
{------------------------------------------------------------------------}
procedure LeftWind;
var i, iend: integer;
begin
(*
   wr1s:='X='+StrR(Currx,5,3)+'  StepX='+StrR(stepX,5,3)+
         '  DF='+StrR(DF(CurrX),8,2)+'  It='+StrW(MaxIter,3);
*)
   with wind2 do
   begin
      Tex[1]:=empty;
      Tex[2]:=' Step X';
      Tex[3]:=' '+StrR(StepX,5,2);
      Tex[4]:=empty;
      Tex[5]:=' Hid.iter.';
      Tex[6]:=' '+StrI(hiditer,0);
      Tex[7]:=empty;
      Tex[8]:=' Vis.iter.';
      Tex[9]:=' '+StrI(maxiter-hiditer,0);
   end;
   if wind2.pt<>nil then WriteWind(wind2);
end;
{------------------------------------------------------------------------}
procedure redraw(tyy: string);
var b1, b2: boolean;
begin
   b1:=wind1.bool; b2:=wind2.bool;
   if b1 then OpenCloseWind(wind1,0);
   if b2 then OpenCloseWind(wind2,0);
   ClearDevice;
   DrawF(15);
   Wr(Tyy,15); Wr1;
   if b1 then OpenCloseWind(wind1,0);
   if b2 then OpenCloseWind(wind2,0);
end;
{------------------------------------------------------------------------}
procedure ChangeMu;
var muNew, muOld: real;

procedure NewDraw;
begin
   if muNew<>mu then
   begin
      muOld:=mu;
      mu:=muNew; DrawF(14);
      mu:=muOld; DrawF(0);
      mu:=muNew; DrawF(15);
      FixPoint;
   end;
end;

procedure BiffMu;
var muEnd, rstep: real;
begin
   OpenCloseWind(wind1,0);
   muEnd:=mu+muLong;
   muNew:=mu;
   rstep:=(muEnd-muNew)/600.0;
   NewDraw;
   repeat
       NewDraw;
       wr1s:=' Mu='+StrR(mu,5,3);
       Wr2;
{       writewind(wind1); }
       muNew:=muNew+rstep;
   until KeyPressed or (mu>muEnd);
   stop;
   CloseWind(wind1);  CloseWind(wind2);
end;
{------------------------------------------------------------------------}
var ch, ch1: char;
    rr: real;
    ss: string;
const Tyy='Mu: F3, F4, F7, Bif, +, -, Mu, Step,  Quit';
begin
   muNew:=mu;
   WrS; WrE; Wr(Tyy,15);
   wr1s:=' StepMu='+StrR(stepMu,5,3);
   Wr1;

   repeat
       Get2Keys(ch,ch1);
       case UpCase(ch) of
         Key_Nul: case ch1 of
                     Key_F3: OpenCloseWind(wind1,0);
                     Key_F4: OpenCloseWind(wind2,0);
                     Key_F7: redraw(Tyy);
                  end; { case }
          '+': muNew:=mu+stepMu;
          '-': muNew:=mu-stepMu;
          'B': BiffMu;
          'S': begin
                  WrS; WrE;
                  ss:='Mu: Enter number for Step Mu: ';
                  if RWGreal(ss, rr) then stepMu:=rr;
               end;
          'M': begin
                  WrS; WrE;
                  ss:='Mu: Enter number for Mu: ';
                  if RWGreal(ss, rr) then muNew:=rr;
               end;
          'C': begin
                  ClearDevice;
                  DrawF(15);
               end;
       end; { case }
       NewDraw;

       wr1s:=' StepMu='+StrR(stepMu,5,3);
       Wr1;
       if UpCase(ch) in ['S','M','C'] then
       begin
          WrS; WrE; Wr(Tyy,15);
       end;
   until UpCase(ch)='Q';
   CloseWind(wind1);  CloseWind(wind2);
end; { ChangeMu }
{------------------------------------------------------------------------}
procedure Biff;
var ix, co: integer;

procedure DrawPer;
var x0, y0: numType;
    i, iy : integer;
begin
   SetColor(13);
   x0:=random;
   for i:=1 to maxIter do
   begin
      y0:=F(x0,comp);
      if abs(y0)<1000 then iy:=GMY-Trxy(aly,bey,y0) else iy:=-200;
      if iy>-200 then
         if i>hidIter then
      begin
         iy:=GMY-Trxy(aly,bey,y0);
         co:=GetPixel(ix,iy);
         if co=15 then co:=0;
         PutPixel(ix,iy,co+1);
       end;
      x0:=y0;
   end;
end;

procedure SolveEq;
var i, iy, co : integer;
begin
   SetColor(13);
   FixPoint;
   for i:=1 to numFix do
   begin
      iy:=GMY-Trxy(aly,bey,Fix[i]);
      if abs(DFix[i])<1 then co:=14 else co:=15;
      PutPixel(ix,iy,co);
    end;
end;

var ch, ch1: char;
    rrmu, rstep, muend: real;
const Tyy='Press any key to stop or Q to exit.';
begin
   ClearDevice; WrS; WrE; Wr(Tyy,15);
   wr1s:=' Mu='+StrR(mu,5,3);
   Wr1;
   OpenCloseWind(wind1,0);

   rrmu:=mu;
   muEnd:=mu+muLong;
   rstep:=(muEnd-mu)/600.0;
   ix:=1;
   repeat
       wr1s:=' Mu='+StrR(mu,5,3);
       Wr2;
       SolveEq;
       writewind(wind1);
       mu:=mu+rstep;
       ix:=ix+1;
       if keypressed then ch:=Get1Key;
   until (UpCase(ch)='Q') or (mu>muEnd);
   if mu>muEnd then stop;
   ClearDevice;
   CloseWind(wind1);  CloseWind(wind2);
   mu:=rrmu;
end; { Biff }
{------------------------------------------------------------------------}
procedure Orbit;

procedure DrawT;
var x0, y0: numType;
    i, ix, iy : integer;
    bool: boolean;
begin
{   SetWriteMode(XORput); }
   SetColor(13);
   x0:=Currx; bool:=true;
   MoveTo(Trxy(alx,bex,x0),GMY-Trxy(aly,bey,x0));
   for i:=1 to maxIter do
   begin
      y0:=F(x0,comp);
      ix:=Trxy(alx,bex,x0);
      if bool then
      begin
         if abs(y0)<1000 then iy:=GMY-Trxy(aly,bey,y0) else iy:=-200;
         if iy>-200 then
         if i>hidIter then
         begin
            LineTo(ix,iy);
            LineTo(Trxy(alx,bex,y0),iy);
         end else
         begin
            MoveTo(ix,iy);
            MoveTo(Trxy(alx,bex,y0),iy);
         end;
         x0:=y0;
         if (ix<-100) or (ix>GetMaxX+100) then bool:=false;
      end else exit;
   end;
   SetWriteMode(CopyPut);
end;

procedure LineX;
var ii: integer;
begin
   SetColor(7);
   SetWriteMode(XORput);
   ii:=Trxy(alx,bex,Currx);
   Line(ii,GMY,ii,GMY0);
   SetWriteMode(CopyPut);
end;

var ch, ch1: char;
const Tyy='Orbit: F3, F7, l-arr, r-arr, Draw, X, Step x, Iter, Quit';
var x0: numType;
    rr: real;
    ss: string;
    ii, ii2, cod: integer;

begin { Orbit }
   LineX;
wr1s:='X='+StrR(Currx,5,3)+'  F='+StrR(F(Currx,comp),5,3)+'  DF='+StrR(DF(CurrX),8,2);
   Wr1;
   WrS; WrE; Wr(Tyy,15);
   LeftWind;
   repeat
       Get2Keys(ch,ch1);
       case UpCase(ch) of
          Key_Nul: case ch1 of
                      Key_F3: OpenCloseWind(wind1,0);
                      Key_F4: OpenCloseWind(wind2,0);
                      Key_F7: begin
                                 redraw(Tyy); LineX;
                              end;
                      Key_ArrL, Key_ArrR:
                              begin
                                 if ch1=Key_ArrL then x0:=Currx-stepX
                                                 else x0:=Currx+stepX;
                                 LineX; Currx:=x0; LineX;
wr1s:='X='+StrR(Currx,5,3)+'  F='+StrR(F(Currx,comp),5,3)+'  DF='+StrR(DF(CurrX),8,2);
                                 Wr2;
                              end;
                   end; { case }
          'X': begin
                  WrS; WrE;
                  ss:='Orbit: Enter X: ';
                  if RWGreal(ss, rr) then
                  if (rr>=x1) and (rr<=x2) then x0:=rr;
                  if UpCase(ss[1])='F' then
                  begin
                     delete(ss,1,1);
                     val(ss,rr,cod);
                     if (cod=0) and
                        (round(rr)<=numFix) then x0:=Fix[round(rr)];
                  end;
                  LineX; Currx:=x0; LineX;
wr1s:='X='+StrR(Currx,5,3)+'  F='+StrR(F(Currx,comp),5,3)+'  DF='+StrR(DF(CurrX),8,2);
                  Wr2; WrS; WrE; Wr(Tyy,15);
               end;
          'I': begin
                  WrS; WrE;
                  ss:='Orbit: Enter number of hidden iter. and visible iter.: ';
                  if RWGint2(ss, ii2,ii)=2 then
                  begin
                     hidIter:=ii2;
                     if ii>0 then maxIter:=hidIter+ii;
                  end;
                  LeftWind; WrS; WrE; Wr(Tyy,15);
               end;
          'D': DrawT;
          'S': begin
                  WrS; WrE;
                  ss:='Orbit: Enter number for Step X: ';
                  if RWGreal(ss, rr) then stepX:=rr;
                  LeftWind; WrS; WrE; Wr(Tyy,15);
               end;
       end; { case }
   until UpCase(ch)='Q';
   LineX;
   CloseWind(wind1);  CloseWind(wind2);
end; { Orbit }
{------------------------------------------------------------------------}
procedure ChangeFun;
var ss: string;
    ii: integer;
begin
   WrS; WrE;
   ss:='Enter number of function [1..'+StrI(MaxFun,0)+']: ';
   if RWGint(ss, ii) then
     if (ii>=1) and (ii<=MaxFun) then numDS:=ii;
   ClearDevice;
end;
{------------------------------------------------------------------------}
procedure Trans;
begin
   transform(x1,x2,0,GetMaxX, alx,bex);
   transform(y1,y2,GMY0,GMY, aly,bey);
   stepxdrawF:=(x2-x1)/(GetMaxX+10);
   currX:=(x1+x2)/2;
   if x2-x1<1 then stepx:=0.05 else
   if x2-x1<5 then stepx:=0.1 else
   if x2-x1<10 then stepx:=0.5 else
   if x2-x1<100 then stepx:=5 else stepx:=10;
end;
{------------------------------------------------------------------------}
procedure Scale;
var ss: string;
    r1,r2: real;
begin
   WrS; WrE;
   ss:='Scale: ['+StrR(x1,5,3)+','+StrR(x2,5,3)+']  Enter new bounds: ';
   if RWGreal2(ss,r1,r2)=2 then
      if r1<r2 then
   begin
      x1:=r1;  x2:=r2;
      y1:=r1;  y2:=r2;
   end;
   Trans;
   FixPoint;
end;
{------------------------------------------------------------------------}
procedure composition;
var ss: string;
    ii: integer;
begin
   WrS; WrE;
   ss:='Enter composition number [1..6]: ';
   if RWGint(ss, ii) then
     if (ii>=1) and (ii<=4) then comp:=ii;
end;
{------------------------------------------------------------------------}
procedure WriteFunctions;
var i: integer;
begin
   ClearDevice; GotoXY(1,1);
   for i:=1 to maxFun do writeln(i:2,':F(x)=',Fstr[i]);
   stop;
end;
{------------------------------------------------------------------------}
var ch, ch1: char;
const Tyy='DYSY: F1,F3,F4,F7, Bif, Functions, comPosition, Mu, Scale, Orbit, ESC';

begin { Grafic }
   Trans; ch:='O';
   FixPoint;
   repeat
      if UpCase(ch) in ['B','O','C','S','M','P'] then
      begin
         DrawF(15);;
         WrS; WrE; Wr(Tyy,15);
         wr1s:=empty; Wr1;
      end;

      Get2Keys(ch,ch1);
      case UpCase(ch) of
         Key_Nul: case ch1 of
                     Key_F1: begin
                                WriteFunctions;
                                redraw(Tyy);
                             end;
                     Key_F3: OpenCloseWind(wind1,0);
                     Key_F4: OpenCloseWind(wind2,0);
                     Key_F7: redraw(Tyy);
                  end; { case }
         'B': Biff;
         'O': begin
                 CloseWind(wind1);  CloseWind(wind2);
                 Orbit;
              end;
         'F': begin
                 ChangeFun; FixPoint; redraw(Tyy);
              end;
         'S': begin
                 Scale;  redraw(Tyy);
              end;
         'M': begin
                 CloseWind(wind1);  CloseWind(wind2);
                 ChangeMu;
              end;
         'P': begin
                 Composition; FixPoint;
              end;
      end; { case }
   until ch=Key_ESC;
   closegraph;
end;
{---------------------------------------------------------------------------}
procedure Init;
begin
   numDS:=1;
   comp:=1;
   mu:=1;
   x1:=-1; x2:=2;
   y1:=-1; y2:=2;
   stepMu:=0.5;
   muLong:=1;
   GMY:=329; GMY0:=11;
end;

{---------------------------------------------------------------------------}
begin
   GraphDriver:=0;
   if not initialize('') then halt;
   if GraphDriver=VGA then SetGraphMode(1);
   DirectVideo := False;
   Init;
   Grafic;
end.