{$F+}
unit NKK;
interface
uses Graph;

type numType=real;
const space=' ';
      empty='';
      pii=3.14159265358979E+0000;

const GraphDriver:integer=0;
      GraphMode:integer=0;
      WrFont: integer=DefaultFont;
var colmode: array[0..15] of integer;

const firmNKK='Copyright (c) NKK';
      space79=
'                                                                              ';
const TypComputer:byte=1;  { 1-lat, 2-cyr }

const a219s: array[1..24] of byte=                  { empty01 for SmallFont }
      (6,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

const empty25=
'';
{ April 27    80 positions ! }
      empty01='';
      empty10='';

type string80=string[80];


type dType=record
              ch: char;
              w: word;
           end;
var RF: file of dType;
const KEY_NUL      =#0;   KEY_NON=#254;
      KEY_enter    =#13;  KEY_esc=#27;
      KEY_backspace=#8 ;  KEY_tab=#9 ;
const DemoScen: byte=0;    { 0 - no, 1 - Demo, 2 - Scen }

{-------------------------------------------------------------------------}
const KEY_F1 =#59;{ ; }
      KEY_F2 =#60;{ < }
      KEY_F3 =#61;{ = }
      KEY_F4 =#62;{ > }
      KEY_F5 =#63;{ ? }
      KEY_F6 =#64;{ @ }
      KEY_F7 =#65;{ A }
      KEY_F8 =#66;{ B }
      KEY_F9 =#67;{ C }
      KEY_F10=#68;{ D }
const KEY_ArrUp=#72;{ H }  KEY_ArrDn=#80;{ P }
      KEY_ArrL =#75;{ K }  KEY_ArrR =#77;{ M }
      KEY_Home =#71;{ G }  KEY_End  =#79;{ O }
      KEY_PgUp =#73;{ I }  KEY_PgDn =#81;{ Q }
      KEY_Ins  =#82;{ R }  KEY_Del  =#83;{ S }

procedure WrE;
procedure Wr(ss:string80; col:integer);
procedure stop;
function trxy(al,be,xy:real): integer;
function StrI(i:integer; pp: integer):string80;
function StrR(r:real; p1,p2:integer):string80;
procedure WrS;
procedure Get2Keys(var c1,c2: char);
function RWGreal(var ss:string80; var rr: real): boolean;
function Get1Key: char;
function RWGint2(ss:string80; var ii1,ii2: integer): byte;
function RWGint(var ss:string80; var ii: integer): boolean;
procedure transform(a,b,c,d:numType; var al,be:numType);
function RWGreal2(ss:string80; var rr1,rr2: real): byte;
function Initialize(ptd: string80): boolean;
procedure PressEnter;

{================================================================}
implementation
uses Crt, Dos;

procedure GetDEMO;
var i: integer;
    st: string;
begin
   DemoScen:=0;
   for i:=1 to ParamCount do
   begin
      st:=paramstr(i);
      if (st>'') then
      if copy(st,1,2)='$D' then DemoScen:=1 else
      if copy(st,1,2)='$S' then DemoScen:=2;
   end;
end; { GetDEMO }
{------------------------------------------------------------------}
procedure OpenRF(st:string80);
begin
   if DemoScen>0 then
   begin
      assign(RF,st+'.RF');
      case DemoScen of
         1: reset(RF);
         2: rewrite(RF);
      end; { case }
   end;
end;
{------------------------------------------------------------------}
procedure CloseRF;
begin
   if DemoScen>0 then close(RF);
end;
{------------------------------------------------------------------}

function ReadKeyNKK: char;

procedure case1;
var dt: dType;
begin
   with dt do
   begin
      read(RF,dt);
      delay(w*10);     { *1000 }
      ReadKeyNKK:=ch;
   end;
end; { case1 }

procedure case2;
var ch: char;
    h,m,s,s100: word;
    t, t1: longint;
    dt: dType;
begin
   GetTime(h,m,s,s100);
   t:=(h*60+m)*60+s;
   ch:=ReadKey;
   GetTime(h,m,s,s100);
   t1:=(h*60+m)*60+s;

   ReadKeyNKK:=ch;
   dt.ch:=ch;
   dt.w:=t1-t;
   write(RF,dt);
end; { case2 }

begin { ReadKeyNKK }
   case DemoScen of
      0: ReadKeyNKK:=ReadKey;
      1: case1;
      2: case2;
   end;
end; { ReadKeyNKK }

procedure FillText25;
var dy: integer;
    co: word;
    pp: array[1..4] of pointtype;
begin
   co:=GetColor;
   dy:=GetMaxY-TextHeight('A');

   SetColor(0);
   pp[1].x:=0;             pp[1].y:=GetMaxY+1;
   pp[2].x:=0;             pp[2].y:=dy-5;
   pp[3].x:=GetMaxX+1;     pp[3].y:=dy-5;
   pp[4].x:=GetMaxX+1;     pp[4].y:=GetMaxY+1;

   SetFillStyle(1,0);
   FillPoly(4,pp);
   SetColor(co);
end;

procedure WrE;
var co: word;
   dy, i: integer;
begin
   SetTextStyle(WrFont,HorizDir,0);
   co:=GetColor;
   dy:=GetMaxY-TextHeight('A');
   case WrFont of
      DefaultFont:  FillText25;
(*
                  begin
                      SetColor(0);
                      OutTextXY(2,dy-1,empty25);
                   end;
*)
      SmallFont: for i:=1 to 100 do PutImage(i*6,dy,a219s,CopyPut);
   end;
   SetColor(co);
end;

procedure Wr(ss:string80; col:integer);   { with colmode !!!!! }
var i, dy, dx, co: integer;
begin
   SetTextStyle(WrFont,HorizDir,0);
   co:=GetColor;
   dy:=GetMaxY-TextHeight('Ay');
   dx:=TextWidth('A');

   case WrFont of
      DefaultFont: MoveTo(2,dy-1);
      SmallFont  : MoveTo(2,dy-1);
   end;

   for i:=1 to length(ss) do
   begin
      SetColor(0);
      case WrFont of
         DefaultFont: begin
                        OutText(empty01);
                        MoveTo(GetX-dx,GetY);
                     end;
         SmallFont: PutImage(GetX,dy,a219s,CopyPut);
      end;

      if col>0 then
         if ss[i] in ['A'..'Z',''..''] then SetColor(colmode[col-1])
                                         else SetColor(colmode[col])
               else SetColor(0);
      OutText(ss[i]);
   end;
   SetColor(co);
end;

{1b}
procedure Get2Keys(var c1,c2: char);
begin
   while Keypressed do c1:=ReadKey;
   c1:=ReadKeyNKK;
   if c1=Key_NUL then c2:=ReadKeyNKK;
end;

{2b}
function Get1Key: char;
var c1, c2: char;
begin
   Get2Keys(c1,c2);
   Get1Key:=c1;
end;


procedure stop;
var cc: char;
begin
   cc:=Get1Key;
end;

procedure transform(a,b,c,d:numType; var al,be:numType);
begin
   al:=(c-d)/(a-b);
   be:=(a*d-c*b)/(a-b);
end;

{2t}
function trxy(al,be,xy:real): integer;
begin
   trxy:=round(al*xy+be);
end;

function StrI(i:integer; pp: integer):string80;
var se: string80;
begin
   str(i:pp,se);
   StrI:=se;
end;

function StrR(r:real; p1,p2:integer):string80;
var se: string80;
begin
   str(r:p1:p2,se);
   StrR:=se;
end;

procedure WrS;
begin
    GotoXY(1,25);
   write(space79);
   GotoXY(1,25);
end;

procedure ReadWriteStrGr(var ss:string80);
var ch, chh: char;
    TST: TextSettingsType;
    ste, ix0, col: integer;
begin
   GetTextSettings(TST);
   col:=GetColor;
   ste:=TextWidth('A');

   ss:=empty;
   ix0:=GetX;
   SetColor(colmode[14]);
   repeat
      Get2Keys(ch,chh);
      if (ch=KEY_Backspace) and (GetX>ix0) then
      begin
         MoveRel(-ste,0);
         case TST.Font of
            DefaultFont: begin
                            SetColor(0);
                            OutText(empty01);
                            MoveRel(-ste,0);
                            SetColor(colmode[14]);
                         end;
           SmallFont : PutImage(GetX,GetY,a219s,CopyPut);
         end;
         delete(ss,length(ss),1);
      end else
      if ch in [space..''] then
      begin
         ss:=ss+ch;
         OutText(ch);
      end;
   until (ch=KEY_Enter) or (ch=KEY_ESC);
   SetColor(col);
   if ch=KEY_ESC then ss:=empty+KEY_ESC;
end; { ReadWriteStrGr }

function RWGreal(var ss:string80; var rr: real): boolean;
var cod: integer;
begin
   Wr(ss,14);
   ReadWriteStrGr(ss);
   val(ss,rr,cod);
   if cod=0 then RWGreal:=true else RWGreal:=false;
end; { RWGreal }

function FindSpace(ss:string80): byte;
var i: integer;
begin
   i:=1;
   while (ss[i]<>space) and (i<length(ss)) do i:=i+1;
   if (i=1) or (i=length(ss)) then FindSpace:=0 else FindSpace:=i;
end;


function RWGint2(ss:string80; var ii1,ii2: integer): byte;
                { get 1 or 2 numbers }
var sp, cod: integer;
begin
   Wr(ss,14);
   RWGint2:=0;
   ReadWriteStrGr(ss);

   sp:=FindSpace(ss);
   if sp>1 then
   begin
      val(copy(ss,1,sp-1),ii1,cod);
      if cod<>0 then exit;

      ss:=copy(ss,sp+1,length(ss)-sp);
      val(ss,ii2,cod);
      if cod<>0 then exit;
      RWGint2:=2;
   end else
   begin
      val(ss,ii1,cod);
      if cod<>0 then exit;
      RWGint2:=1;
   end;
end; { RWGint2 }

function RWGint(var ss:string80; var ii: integer): boolean;
var cod, ste: integer;
begin
   Wr(ss,14);
   ReadWriteStrGr(ss);
   val(ss,ii,cod);
   if cod=0 then RWGint:=true else RWGint:=false;
end; { RWGint }

function RWGreal2(ss:string80; var rr1,rr2: real): byte;
                { get 1 or 2 numbers }
var sp, cod: integer;
begin
   Wr(ss,14);
   RWGreal2:=0;
   ReadWriteStrGr(ss);

   sp:=FindSpace(ss);
   if sp>1 then
   begin
      val(copy(ss,1,sp-1),rr1,cod);
      if cod<>0 then exit;

      ss:=copy(ss,sp+1,length(ss)-sp);
      val(ss,rr2,cod);
      if cod<>0 then exit;
      RWGreal2:=2;
   end else
   begin
      val(ss,rr1,cod);
      if cod<>0 then exit;
      RWGreal2:=1;
   end;
end; { RWGreal2 }

procedure SetColMode;
var i: integer;
begin
   GraphMode:=GetGraphMode;
   colmode[0]:=0;
   case GraphDriver of
      CGA: case GraphMode of
            0..3: begin
                     for i:=1 to 15 do colmode[i]:=3;
                     colmode[white]:=3;
                     colmode[red]:=2;
                     colmode[blue]:=1;
                     colmode[13]:=2;
                     colmode[14]:=1;
                     WrFont:=SmallFont;
                  end;
              4: begin
                    for i:=1 to 15 do colmode[i]:=1;
                    WrFont:=DefaultFont;
                 end;
           end; { case }
      EGA, VGA: begin
                 for i:=0 to 15 do colmode[i]:=i;
              WrFont:=DefaultFont;
           end;
   end;   { case }
end;

function Initialize(ptd: string80): boolean;
{ Initialize graphics and report any errors that may occur }
var ErrorCode   : integer;  { Reports any graphics errors }
    i: integer;
begin
  { when using Crt and graphics, turn off Crt's memory-mapped writes }
  DirectVideo := True;

  InitGraph(GraphDriver, graphmode,ptd);       { activate graphics }
  ErrorCode := GraphResult;                    { error? }
  if ErrorCode <> grOk then
  begin
    Writeln('Graphics error: ErrorCode=',ErrorCode);
    writeln('GraphErrorMsg(ErrorCode)=',GraphErrorMsg(ErrorCode));
    Initialize:=false;
    PressEnter;
  end else Initialize:=true;
  SetColMode;
end; { Initialize }



procedure PressEnter;
var ch: char;
begin
   writeln;
   TextColor(red);
   write('Press Enter . . .');
   TextColor(15);
   stop;
   writeln;
end;

{-------------------------------------------------------------------------}

{$F+}                                      { from \tp\pas\mcutil.pas }
function HeapFunc(Size : Word) : Word;
{ Used to handle heap errors }
begin
  HeapFunc := 1;       { Forces New or GetMem to return a nil pointer }
end; { HeapFunc }
{$F-}

{===========================================================================}
begin { unit NKK }
   HeapError := @HeapFunc;
end. { unit NKK }